## Run from tf_raycast:start_raycast

# Using dx for precise hitbox detection
# Used and edited by LPMC2 (Originally from Cloud Wolf if I remembered Correctly...)
# Parameters:
#     Edit not_mob.json in tags/entities to change which entities will not be targetted
#     Change the "positioned" offsets to change projectile size
#       - If > 1 block, just use one dx detection
execute positioned ~ ~ ~ if entity @e[tag=!raycasting,type=item,distance=..0.5,sort=nearest,limit=1] run execute store result score @s thrower run data get entity @s Owner
execute as @e[tag=!raycasting,type=item,dx=0] positioned ~-0.5 ~-0.5 ~-0.5 run execute store result score @s thrower run data get entity @s Owner
execute as @e[tag=!raycasting,type=item,dx=0,scores={thrower=..0}] positioned ~-0.5 ~-0.5 ~-0.5 run execute positioned ~0.5 ~0.5 ~0.5 run function zombies:cleavingcollide

scoreboard players add .distance tf_rc 1

# Make raycast visible



# Repeat the raycast if certain conditions are met
# Parameters:
#    (score after "matches") * (accuracy increment) = range
#    The "positioned" value specifies the precision
#    Edit raycast_pass.json in tags/blocks to change which blocks the raycast ignores
#    "rotated" controls arc/curve of raycast path
execute if score .distance tf_rc matches ..50 positioned ^ ^ ^0.1 rotated ~ ~ run function zombies:cleavingraycast1
